; ************************************************************************
; Waveguide model of Organ Flue
; Coded 2/20/97 by Hans Mikelson
; From an instrument by Slawomir Zielinski http://next.eti.pg.gda.pl/
;*************************************************************************

sr = 44100
kr = 4410
ksmps = 10
nchnls = 1

       instr   1 ; Waveguide flue pipe

idur   =       p3
iamp   =       p4
ifqc   =       cpspch(p5)
ipress =       p6
iattk  =       p7

; Coefficients
kn     init    .089
kr1    init    .202
kr2    init    .520
ka     init   -.164
kb     init   -.582
kc     init   -.433
ia1    init   -.8
ib0    init   -.3
adl1   init    0

kg     linseg   0, .002, iamp, idur-.004, iamp, .002, 0
kenv1  linseg   0, .01, ipress*iattk, .1, ipress, idur-.12, ipress, .01, 0
anoise rand     1

amult1 =        anoise * kenv1
asum1  =        kn*amult1 + kenv1
asum2  =        asum1 + kr1*adl1

ax     delayr   1/ifqc/4
       delayw   asum2

asum3  =        ka*ax*ax*ax + kb*ax*ax + kc*ax
asum4  =        asum3 + kr2*adl1

afilt  butterlp asum4, 5000
adl1   delayr   1/ifqc
       delayw   afilt

afilt2 butterhp afilt, 100

       out      kg*afilt2

       endin

